import { Actor, ActorCons, ActorRef } from "./Actor";
import { Address, Channel, Strategy } from "./interfaces";
export declare type ActorConstructorOptions<T extends Actor<K>, K = undefined> = {
    name: string;
    actorClass: ActorCons<T, K>;
    paramOptions?: K;
    strategies?: Strategy[];
};
export declare class ActorSystem {
    name: string;
    protected actorRegistry: {
        [address: string]: Actor<any>;
    };
    private actorSystemRegistry;
    constructor(name?: string);
    register(emitter: Channel): void;
    unregister(actorSystemAddress: string): void;
    listenTo(emitter: Channel): void;
    createActor: <T extends Actor<K>, K = undefined>(options: ActorConstructorOptions<T, K>) => ActorRef<Pick<T, { [K in Exclude<keyof T, "at" | "atSelf" | "onNewMessage" | "pushToMailbox" | "ref">]: T[K] extends (...args: any[]) => infer R ? R extends Promise<any> ? K : never : never; }[Exclude<keyof T, "at" | "atSelf" | "onNewMessage" | "pushToMailbox" | "ref">]>>;
    removeActor: (refOrAddress: ActorRef<any> | Address) => void;
    ref: <T>(address: Address) => ActorRef<T>;
    findActor: <T>(address: Address) => ActorRef<T> | null;
    sendMessage: (target: ActorRef<any> | Address, type: string, senderAddress: Address | null, ...payload: any[]) => Promise<any>;
    isLocalAddress(address: Address): boolean;
    private log(...message);
}
